Index: branch/sabot/sp4abc/sp4b1/SP4b1/SP4b1.hwp
===================================================================
--- branch/sabot/sp4abc/sp4b1/SP4b1/SP4b1.hwp	(revision 486)
+++ branch/sabot/sp4abc/sp4b1/SP4b1/SP4b1.hwp	(revision 487)
@@ -3,16 +3,16 @@
 [DATABASE_VERSION]
 "2.8" 
 [PROJECT_DETAILS]
-"SP4b1" "D:\tp_sp4_SABOT\sp4abc\sp4b1\SP4b1" "D:\tp_sp4_SABOT\sp4abc\sp4b1\SP4b1\SP4b1.hwp" "M16C/80,M32C" "Renesas M32C Standard" "Application" "M32C/80" "M32C/87(M32C/87)" 
+"SP4b1" "D:\tp_sp4_SABOT\sabot\sp4abc\sp4b1\SP4b1" "D:\tp_sp4_SABOT\sabot\sp4abc\sp4b1\SP4b1\SP4b1.hwp" "M16C/80,M32C" "Renesas M32C Standard" "Application" "M32C/80" "M32C/87(M32C/87)" 
 [INFORMATION]
 "No project information available" 
 [TOOL_CHAIN]
 "Renesas M32C Standard Toolchain" "5.42.00" 
 [CONFIGURATIONS]
-"Debug" "D:\tp_sp4_SABOT\sp4abc\sp4b1\SP4b1\Debug" 
-"Debug_M32C_E8a_SYSTEM" "D:\tp_sp4_SABOT\sp4abc\sp4b1\SP4b1\Debug_M32C_E8a_SYSTEM" 
-"Debug_M32C_Simulator" "D:\tp_sp4_SABOT\sp4abc\sp4b1\SP4b1\Debug_M32C_Simulator" 
-"Release" "D:\tp_sp4_SABOT\sp4abc\sp4b1\SP4b1\Release" 
+"Debug" "D:\tp_sp4_SABOT\sabot\sp4abc\sp4b1\SP4b1\Debug" 
+"Debug_M32C_E8a_SYSTEM" "D:\tp_sp4_SABOT\sabot\sp4abc\sp4b1\SP4b1\Debug_M32C_E8a_SYSTEM" 
+"Debug_M32C_Simulator" "D:\tp_sp4_SABOT\sabot\sp4abc\sp4b1\SP4b1\Debug_M32C_Simulator" 
+"Release" "D:\tp_sp4_SABOT\sabot\sp4abc\sp4b1\SP4b1\Release" 
 [BUILD_PHASES]
 "Renesas M32C Assembler" 1 
 "Renesas M32C C Compiler" 1 
@@ -105,8 +105,8 @@
 "Relocatable file" "Renesas M32C Linker" "Renesas M32C Assembler" 
 "Relocatable file" "Renesas M32C Linker" "Renesas M32C C Compiler" 
 [PROJECT_FILES]
-"D:\tp_sp4_SABOT\sp4abc\sp4b1\SP4b1\SP4b1.c" "User" "C source file" 2 
-"D:\tp_sp4_SABOT\sp4abc\sp4b1\SP4b1\ncrt0.a30" "User" "Assembly source file" 2 
+"D:\tp_sp4_SABOT\sabot\sp4abc\sp4b1\SP4b1\SP4b1.c" "User" "C source file" 2 
+"D:\tp_sp4_SABOT\sabot\sp4abc\sp4b1\SP4b1\ncrt0.a30" "User" "Assembly source file" 2 
 [FOLDER]
 "Assembly source file" "Assembly source file" 
 "C source file" "C source file" 
@@ -115,18 +115,18 @@
 [ON_DEMAND_COMPONENTS_LOADED]
 [SYNC_SESSION_NAMES]
 [SESSIONS]
-"DefaultSession" "D:\tp_sp4_SABOT\sp4abc\sp4b1\SP4b1\DefaultSession.hsf" 0 
-"SessionM32C_E8a_SYSTEM" "D:\tp_sp4_SABOT\sp4abc\sp4b1\SP4b1\SessionM32C_E8a_SYSTEM.hsf" 0 
-"SessionM32C_Simulator" "D:\tp_sp4_SABOT\sp4abc\sp4b1\SP4b1\SessionM32C_Simulator.hsf" 0 
+"DefaultSession" "D:\tp_sp4_SABOT\sabot\sp4abc\sp4b1\SP4b1\DefaultSession.hsf" 0 
+"SessionM32C_E8a_SYSTEM" "D:\tp_sp4_SABOT\sabot\sp4abc\sp4b1\SP4b1\SessionM32C_E8a_SYSTEM.hsf" 0 
+"SessionM32C_Simulator" "D:\tp_sp4_SABOT\sabot\sp4abc\sp4b1\SP4b1\SessionM32C_Simulator.hsf" 0 
 [GENERAL_DATA_SESSION_DefaultSession]
 [GENERAL_DATA_SESSION_SessionM32C_E8a_SYSTEM]
 [GENERAL_DATA_SESSION_SessionM32C_Simulator]
 [OPTIONS_Debug_Renesas M32C Assembler]
 "Assembly source file" "0f5d646238d47d10" 2 
-"D:\tp_sp4_SABOT\sp4abc\sp4b1\SP4b1\ncrt0.a30" "0f5d646238d47d10" 2 
+"D:\tp_sp4_SABOT\sabot\sp4abc\sp4b1\SP4b1\ncrt0.a30" "0f5d646238d47d10" 2 
 [OPTIONS_Debug_Renesas M32C C Compiler]
 "C source file" "0f5d646238d47d10" 1 
-"D:\tp_sp4_SABOT\sp4abc\sp4b1\SP4b1\SP4b1.c" "0f5d646238d47d10" 1 
+"D:\tp_sp4_SABOT\sabot\sp4abc\sp4b1\SP4b1\SP4b1.c" "0f5d646238d47d10" 1 
 [OPTIONS_Debug_Renesas M32C Configurator]
 "Single Shot" "0f5d646238d47d10" 6 
 [OPTIONS_Debug_Renesas M32C Librarian]
@@ -145,14 +145,14 @@
 "[V|VERSION|1] [S|OUTPUT|OBJECTCODE] [S|OUTPUTPATH|^"$(CONFIGDIR)\$(FILELEAF).r30^"] [B|INSPECTOR|1] [S|CPU|M32C80] " 1 
 [EXCLUDED_FILES_Debug]
 [LINKAGE_ORDER_Debug]
-"D:\tp_sp4_SABOT\sp4abc\sp4b1\SP4b1\Debug\ncrt0.r30" 
+"D:\tp_sp4_SABOT\sabot\sp4abc\sp4b1\SP4b1\Debug\ncrt0.r30" 
 [GENERAL_DATA_CONFIGURATION_Debug]
 [OPTIONS_Debug_M32C_E8a_SYSTEM_Renesas M32C Assembler]
 "Assembly source file" "0f5d646238d47d10" 2 
-"D:\tp_sp4_SABOT\sp4abc\sp4b1\SP4b1\ncrt0.a30" "0f5d646238d47d10" 2 
+"D:\tp_sp4_SABOT\sabot\sp4abc\sp4b1\SP4b1\ncrt0.a30" "0f5d646238d47d10" 2 
 [OPTIONS_Debug_M32C_E8a_SYSTEM_Renesas M32C C Compiler]
 "C source file" "0f5d646238d47d10" 1 
-"D:\tp_sp4_SABOT\sp4abc\sp4b1\SP4b1\SP4b1.c" "0f5d646238d47d10" 1 
+"D:\tp_sp4_SABOT\sabot\sp4abc\sp4b1\SP4b1\SP4b1.c" "0f5d646238d47d10" 1 
 [OPTIONS_Debug_M32C_E8a_SYSTEM_Renesas M32C Configurator]
 "Single Shot" "0f5d646238d47d10" 6 
 [OPTIONS_Debug_M32C_E8a_SYSTEM_Renesas M32C Librarian]
@@ -171,14 +171,14 @@
 "[V|VERSION|1] [S|OUTPUT|OBJECTCODE] [S|OUTPUTPATH|^"$(CONFIGDIR)\$(FILELEAF).r30^"] [B|INSPECTOR|1] [S|CPU|M32C80] " 1 
 [EXCLUDED_FILES_Debug_M32C_E8a_SYSTEM]
 [LINKAGE_ORDER_Debug_M32C_E8a_SYSTEM]
-"D:\tp_sp4_SABOT\sp4abc\sp4b1\SP4b1\Debug_M32C_E8a_SYSTEM\ncrt0.r30" 
+"D:\tp_sp4_SABOT\sabot\sp4abc\sp4b1\SP4b1\Debug_M32C_E8a_SYSTEM\ncrt0.r30" 
 [GENERAL_DATA_CONFIGURATION_Debug_M32C_E8a_SYSTEM]
 [OPTIONS_Debug_M32C_Simulator_Renesas M32C Assembler]
 "Assembly source file" "0f5d646238d47d10" 2 
-"D:\tp_sp4_SABOT\sp4abc\sp4b1\SP4b1\ncrt0.a30" "0f5d646238d47d10" 2 
+"D:\tp_sp4_SABOT\sabot\sp4abc\sp4b1\SP4b1\ncrt0.a30" "0f5d646238d47d10" 2 
 [OPTIONS_Debug_M32C_Simulator_Renesas M32C C Compiler]
 "C source file" "0f5d646238d47d10" 1 
-"D:\tp_sp4_SABOT\sp4abc\sp4b1\SP4b1\SP4b1.c" "0f5d646238d47d10" 1 
+"D:\tp_sp4_SABOT\sabot\sp4abc\sp4b1\SP4b1\SP4b1.c" "0f5d646238d47d10" 1 
 [OPTIONS_Debug_M32C_Simulator_Renesas M32C Configurator]
 "Single Shot" "0f5d646238d47d10" 6 
 [OPTIONS_Debug_M32C_Simulator_Renesas M32C Librarian]
@@ -197,14 +197,14 @@
 "[V|VERSION|1] [S|OUTPUT|OBJECTCODE] [S|OUTPUTPATH|^"$(CONFIGDIR)\$(FILELEAF).r30^"] [B|INSPECTOR|1] [S|CPU|M32C80] " 1 
 [EXCLUDED_FILES_Debug_M32C_Simulator]
 [LINKAGE_ORDER_Debug_M32C_Simulator]
-"D:\tp_sp4_SABOT\sp4abc\sp4b1\SP4b1\Debug_M32C_Simulator\ncrt0.r30" 
+"D:\tp_sp4_SABOT\sabot\sp4abc\sp4b1\SP4b1\Debug_M32C_Simulator\ncrt0.r30" 
 [GENERAL_DATA_CONFIGURATION_Debug_M32C_Simulator]
 [OPTIONS_Release_Renesas M32C Assembler]
 "Assembly source file" "0f5d646238d47d10" 2 
-"D:\tp_sp4_SABOT\sp4abc\sp4b1\SP4b1\ncrt0.a30" "0f5d646238d47d10" 2 
+"D:\tp_sp4_SABOT\sabot\sp4abc\sp4b1\SP4b1\ncrt0.a30" "0f5d646238d47d10" 2 
 [OPTIONS_Release_Renesas M32C C Compiler]
 "C source file" "0f5d646238d47d10" 1 
-"D:\tp_sp4_SABOT\sp4abc\sp4b1\SP4b1\SP4b1.c" "0f5d646238d47d10" 1 
+"D:\tp_sp4_SABOT\sabot\sp4abc\sp4b1\SP4b1\SP4b1.c" "0f5d646238d47d10" 1 
 [OPTIONS_Release_Renesas M32C Configurator]
 "Single Shot" "0f5d646238d47d10" 6 
 [OPTIONS_Release_Renesas M32C Librarian]
@@ -223,7 +223,7 @@
 "[V|VERSION|1] [S|OUTPUT|OBJECTCODE] [S|OUTPUTPATH|^"$(CONFIGDIR)\$(FILELEAF).r30^"] [B|INSPECTOR|1] [S|CPU|M32C80] " 1 
 [EXCLUDED_FILES_Release]
 [LINKAGE_ORDER_Release]
-"D:\tp_sp4_SABOT\sp4abc\sp4b1\SP4b1\Release\ncrt0.r30" 
+"D:\tp_sp4_SABOT\sabot\sp4abc\sp4b1\SP4b1\Release\ncrt0.r30" 
 [GENERAL_DATA_CONFIGURATION_Release]
 [GENERAL_DATA_CONFIGURATION_SESSION_Debug_DefaultSession]
 [SESSION_DATA_CONFIGURATION_SESSION_Debug_DefaultSession]
Index: branch/sabot/sp4abc/sp4b1/SP4b1/DefaultSession.hsf
===================================================================
--- branch/sabot/sp4abc/sp4b1/SP4b1/DefaultSession.hsf	(revision 486)
+++ branch/sabot/sp4abc/sp4b1/SP4b1/DefaultSession.hsf	(revision 487)
@@ -34,7 +34,7 @@
 0 
 [WINDOW_POSITION_STATE_DATA_VD1]
 "Help" "TOOLBAR 0" 59419 1 5 "0.00" 0 0 0 0 0 17 0 "" "0.0" 
-"{WK_00000001_CmdLine}" "WINDOW" 59422 0 1 "0.25" 180 0 0 350 200 17 0 "32771|32772|32778|<<separator>>|32773|32774|<<separator>>|32820|<<separator>>|32801|32824" "0.0" 
+"{WK_00000001_CmdLine}" "WINDOW" 59422 0 1 "0.20" 180 0 0 350 200 17 0 "32771|32772|32778|<<separator>>|32773|32774|<<separator>>|32820|<<separator>>|32801|32824" "0.0" 
 "{WK_00000001_OUTPUT}" "WINDOW" 59422 0 0 "1.00" 180 569 307 350 200 18 0 "36756|36757|36758|36759|<<separator>>|36746|36747|<<separator>>|39531|<<separator>>|39500|39534|<<separator>>|36687" "0.0" 
 "{WK_00000002_WORKSPACE}" "WINDOW" 59420 0 0 "1.00" 180 569 307 350 200 18 0 "" "0.0" 
 "{WK_TB00000001_STANDARD}" "TOOLBAR 0" 59419 0 2 "0.00" 0 0 0 0 0 18 0 "" "0.0" 
@@ -54,8 +54,7 @@
 [WINDOW_POSITION_STATE_DATA_VD3]
 [WINDOW_POSITION_STATE_DATA_VD4]
 [WINDOW_Z_ORDER]
-"D:\tp_sp4_SABOT\sp4abc\sp4b1\SP4b1\SP4b1.c" 
-"D:\tp_sp4_SABOT\sp4abc\sp4b1\SP4b1\ncrt0.a30" 
+"D:\tp_sp4_SABOT\sabot\sp4abc\sp4b1\SP4b1\SP4b1.c" 
 [TARGET_NAME]
 "" "" 1853190002 
 [STATUSBAR_STATEINFO_VD1]
Index: branch/sabot/sp4abc/sp4b1/SP4b1/SessionM32C_E8a_SYSTEM.hsf
===================================================================
--- branch/sabot/sp4abc/sp4b1/SP4b1/SessionM32C_E8a_SYSTEM.hsf	(revision 486)
+++ branch/sabot/sp4abc/sp4b1/SP4b1/SessionM32C_E8a_SYSTEM.hsf	(revision 487)
@@ -47,7 +47,7 @@
 "{55384715-F881-421C-A548-D7D1ABE158E1}PDMRCtrlViews" "0" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_EVAL_DENORMAL_MODE" "0" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_EVAL_ROUND_MODE" "0" 
-"{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_0" "00000000000000FD" 
+"{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_0" "0000000000000020" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_1" "0000000000000000" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_10" "0000000000000000" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_11" "0000000000000000" 
@@ -55,12 +55,12 @@
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_13" "0000000000000000" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_14" "0000000000000000" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_15" "0000000000000400" 
-"{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_16" "0000000000FE02ED" 
+"{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_16" "0000000000FE044E" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_17" "0000000000FFFD00" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_18" "00000000000006FE" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_19" "0000000000000A02" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_2" "0000000000000000" 
-"{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_20" "0000000000000081" 
+"{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_20" "0000000000000084" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_21" "0000000000000000" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_22" "0000000000000000" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_23" "0000000000000000" 
@@ -110,11 +110,13 @@
 "{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ColWidth12" "150" 
 "{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ColWidth2" "120" 
 "{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ColWidth3" "200" 
-"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ECX_WATCH_ITEM0000" "touche, 2, 0, P, Col, Hex, MA" 
+"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ECX_WATCH_ITEM0000" "touche, 2, 0, P, Col, Hex, MN" 
 "{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ECX_WATCH_ITEM0000_SCOPE" "Global," 
 "{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ECX_WATCH_ITEM0001" "t, 2, 0, P, Col, Hex, MA" 
 "{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ECX_WATCH_ITEM0001_SCOPE" "Current Scope," 
-"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ECX_WATCH_ITEMCnt" "2" 
+"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ECX_WATCH_ITEM0002" "car, 10, 0, P, Col, Hex, N" 
+"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ECX_WATCH_ITEM0002_SCOPE" "Current Scope," 
+"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ECX_WATCH_ITEMCnt" "3" 
 "{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd1ColWidth0" "120" 
 "{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd1ColWidth1" "150" 
 "{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd1ColWidth12" "150" 
@@ -143,7 +145,7 @@
 "{D3D4595F-12B4-4866-8F9A-78C30AC967E3}T_CONFIG_ROUND" "RM_NEAR" 
 "{D3D4595F-12B4-4866-8F9A-78C30AC967E3}T_CONFIG_STEPOPTION" "0" 
 "{D3D4595F-12B4-4866-8F9A-78C30AC967E3}T_EVENT_BC1" "0,0,1,0,1,0,1,0,0,0" 
-"{D3D4595F-12B4-4866-8F9A-78C30AC967E3}T_EVENT_BC2" "0,0,1,0,1,0" 
+"{D3D4595F-12B4-4866-8F9A-78C30AC967E3}T_EVENT_BC2" "1,1,0,fe0434,1,0" 
 "{D3D4595F-12B4-4866-8F9A-78C30AC967E3}T_EVENT_BC3" "0,0,1,0,1,0,1,0,0,0" 
 "{D3D4595F-12B4-4866-8F9A-78C30AC967E3}T_EVENT_BC4" "0,0,1,0,1,0,1,0,0,0" 
 "{D3D4595F-12B4-4866-8F9A-78C30AC967E3}T_SESSION_IS_SAVED" "YES" 
@@ -704,10 +706,10 @@
 0 
 [WINDOW_POSITION_STATE_DATA_VD1]
 "Help" "TOOLBAR 0" 59419 1 5 "0.00" 0 0 0 0 0 17 0 "" "0.0" 
-"{WK_00000001_CmdLine}" "WINDOW" 59422 0 0 "0.25" 180 0 0 350 200 17 0 "32771|32772|32778|<<separator>>|32773|32774|<<separator>>|32820|<<separator>>|32801|32824" "0.0" 
-"{WK_00000001_IO}SP4b1SessionM32C_E8a_SYSTEM" "WINDOW" 59422 0 1 "0.25" 180 0 0 350 200 18 0 "32817|32826|32819|32820|32821" "0.0" 
-"{WK_00000001_OUTPUT}" "WINDOW" 59422 0 1 "1.00" 180 569 307 350 200 18 0 "36756|36757|36758|36759|<<separator>>|36746|36747|<<separator>>|39531|<<separator>>|39500|39534|<<separator>>|36687" "0.0" 
-"{WK_00000001_WATCH}SP4b1SessionM32C_E8a_SYSTEM" "WINDOW" 59422 0 0 "0.50" 180 0 0 350 200 18 0 "32781|32783|<<separator>>|32771|32829|32772|32827|32773|<<separator>>|32786|<<separator>>|32810|32811|32831" "0.0" 
+"{WK_00000001_CmdLine}" "WINDOW" 59422 0 3 "0.25" 180 0 0 350 200 17 0 "32771|32772|32778|<<separator>>|32773|32774|<<separator>>|32820|<<separator>>|32801|32824" "0.0" 
+"{WK_00000001_IO}SP4b1SessionM32C_E8a_SYSTEM" "WINDOW" 59422 0 2 "0.14" 180 0 0 350 200 18 0 "32817|32826|32819|32820|32821" "0.0" 
+"{WK_00000001_OUTPUT}" "WINDOW" 59422 0 1 "0.57" 180 569 307 350 200 18 0 "36756|36757|36758|36759|<<separator>>|36746|36747|<<separator>>|39531|<<separator>>|39500|39534|<<separator>>|36687" "0.0" 
+"{WK_00000001_WATCH}SP4b1SessionM32C_E8a_SYSTEM" "WINDOW" 59422 0 0 "0.29" 180 0 0 350 200 18 0 "32781|32783|<<separator>>|32771|32829|32772|32827|32773|<<separator>>|32786|<<separator>>|32810|32811|32831" "0.0" 
 "{WK_00000002_WORKSPACE}" "WINDOW" 59420 0 0 "1.00" 180 569 307 350 200 18 0 "" "0.0" 
 "{WK_TB00000001_STANDARD}" "TOOLBAR 0" 59419 0 2 "0.00" 0 0 0 0 0 18 0 "" "0.0" 
 "{WK_TB00000002_EDITOR}" "TOOLBAR 0" 59419 0 0 "0.00" 0 0 0 0 0 18 0 "" "0.0" 
@@ -719,20 +721,20 @@
 "{WK_TB00000009_VERSIONCONTROL}" "TOOLBAR 0" 59419 1 3 "0.00" 0 0 0 0 0 17 0 "" "0.0" 
 "{WK_TB00000011_CPU}" "TOOLBAR 0" 59419 2 2 "0.00" 0 0 0 0 0 18 0 "" "0.0" 
 "{WK_TB00000012_MAP}" "TOOLBAR 0" 59419 1 4 "0.00" 0 0 0 0 0 17 0 "" "0.0" 
-"{WK_TB00000013_SYMBOL}" "TOOLBAR 0" 59419 2 3 "0.00" 0 0 0 0 0 18 0 "" "0.0" 
+"{WK_TB00000013_SYMBOL}" "TOOLBAR 0" 59419 2 4 "0.00" 0 0 0 0 0 18 0 "" "0.0" 
 "{WK_TB00000014_CODE}" "TOOLBAR 0" 59419 2 6 "0.00" 0 0 0 0 0 17 0 "" "0.0" 
 "{WK_TB00000016_GRAPHIC}" "TOOLBAR 0" 59419 2 7 "0.00" 0 0 0 0 0 17 0 "" "0.0" 
 "{WK_TB00000018_DEFAULTWINDOW}" "TOOLBAR 0" 59419 1 2 "0.00" 0 0 0 0 0 17 0 "" "0.0" 
 "{WK_TB00000023_RTOS}" "TOOLBAR 0" 59419 2 8 "0.00" 0 0 0 0 0 17 0 "" "0.0" 
 "{WK_TB00000026_MACRO}" "TOOLBAR 0" 59419 1 6 "0.00" 0 0 0 0 0 17 0 "" "0.0" 
-"{WK_TB00000028_RTOSDEBUG}" "TOOLBAR 0" 59419 2 2 "0.00" 0 0 0 0 0 17 0 "" "0.0" 
-"{WK_TB00000029_SYSTEMTOOL}" "TOOLBAR 0" 59419 2 3 "0.00" 0 0 0 0 0 17 0 "" "0.0" 
+"{WK_TB00000028_RTOSDEBUG}" "TOOLBAR 0" 59419 2 3 "0.00" 0 0 0 0 0 17 0 "" "0.0" 
+"{WK_TB00000029_SYSTEMTOOL}" "TOOLBAR 0" 59419 2 5 "0.00" 0 0 0 0 0 17 0 "" "0.0" 
 [WINDOW_POSITION_STATE_DATA_VD2]
 [WINDOW_POSITION_STATE_DATA_VD3]
 [WINDOW_POSITION_STATE_DATA_VD4]
 [WINDOW_Z_ORDER]
-"D:\tp_sp4_SABOT\sp4abc\sp4b1\SP4b1\SP4b1.c" 
-"D:\tp_sp4_SABOT\sp4abc\sp4b1\SP4b1\ncrt0.a30" 
+"D:\tp_sp4_SABOT\sabot\sp4abc\sp4b1\SP4b1\SP4b1.c" 
+"D:\tp_sp4_SABOT\sabot\sp4abc\sp4b1\SP4b1\ncrt0.a30" 
 [TARGET_NAME]
 "M32C E8a SYSTEM" "" 0 
 [STATUSBAR_STATEINFO_VD1]
@@ -779,4 +781,5 @@
 [FLASH_DETAILS]
 "" 0 0 "" 0 "" 0 0 "" 0 0 0 0 0 0 0 "" "" "" "" "" 
 [BREAKPOINTS]
+"d:\tp_sp4_sabot\sabot\sp4abc\sp4b1\sp4b1\sp4b1.c" 144 16647236 1 "{00000000-0000-0000-C000-000000000046}" "" 
 [END]
Index: branch/sabot/sp4abc/sp4b1/SP4b1/SP4b1.c
===================================================================
--- branch/sabot/sp4abc/sp4b1/SP4b1/SP4b1.c	(revision 486)
+++ branch/sabot/sp4abc/sp4b1/SP4b1/SP4b1.c	(revision 487)
@@ -11,98 +11,160 @@
 
 #include "sfr32c87.h"
 
-#define LCD_E()
-#define LCD_E_DIR()
+#define LCD_E p3_2
+#define LCD_RW p3_1
+#define LCD_DC p3_0
+#define LCD_PORT4 p3_4
+#define LCD_PORT5 p3_5
+#define LCD_PORT6 p3_6
+#define LCD_PORT7 p3_7
 
-#define LCD_RW()
-#define LCD_RW_DIR()
 
-#define LCD_DC()
-#define LCD_DC_DIR()
-
-#define LCD_PORT()
-#define LCD_PORT_DIR()
-
 //temporisation en us
-void tpo_us(unsigned short duree);
+void tpo_us(unsigned short duree){
+	tcspr = 0x8A;
+	ta0mr = 0x82;
+	ta0 = duree;               
+	ta0s = 1;ta0os = 1; 
+	ta0ic = 0x00;                     
+	while(ir_ta0ic != 1);          
+	ta0s = 0;             
+}
 
 // temporisation en ms
-void tpo_ms(unsigned short duree);
+void tpo_ms(unsigned short duree){
+	tpo_us(duree*1000);
+}
 
-
 //envoie des 4 bits de poids fort
 void lcd_4b(unsigned  char car){
-	p1_2=1;
-	p1_2=0;
-	car=3;
-	if (car & 8){
-		p1_4=1;
-	}
-	else{
-		p1_4=0;
-	}
+	LCD_E=1;
+	pd3=0xff;
 	if (car & 16){
-		p1_5=1;
+		LCD_PORT4=1;
 	}
 	else{
-		p1_5=0;
+		LCD_PORT4=0;
 	}
 	if (car & 32){
-		p1_6=1;
+		LCD_PORT5=1;
 	}
 	else{
-		p1_6=0;
+		LCD_PORT5=0;
 	}
 	if (car & 64){
-		p1_7=1;
+		LCD_PORT6=1;
 	}
 	else{
-		p1_7=0;
+		LCD_PORT6=0;
 	}
+	if (car & 128){
+		LCD_PORT7=1;
+	}
+	else{
+		LCD_PORT7=0;
+	}
+	LCD_E=0;
+}
+
+// envoie des 8 bits de donnée 
+void lcd_8b(unsigned  char car){
+	lcd_4b(car);
+	lcd_4b(car<<4);
 	
 }
+//envoi d'une commande
+void lcd_com(unsigned  char com){
+	LCD_DC=0;
+	lcd_8b(com);	
 
-void main(void){
-	lcd_4b(0xF0);
 }
 
+//envoie d'une donnée à l'afficheur
+void lcd_car(unsigned  char car){
+	LCD_DC=1;
+	lcd_8b(car);
+}
 
-//Clavier
-//char t;
-//char touche;
+//initialisation de l'afficheur
+void lcd_init(void){
+	LCD_DC=0;
+	tpo_ms(15);
+	lcd_4b(0x30);
+	tpo_ms(5);
+	lcd_4b(0x30);
+	tpo_us(100);
+	lcd_4b(0x30);
+	tpo_us(100);
+	lcd_4b(0x20);//on ecrit juste une fois(pas 2 segments)
+	lcd_com(0x28);//mode 2 lignes
+	lcd_com(0x06);//incrementation du curseur
+	lcd_com(0x0E);//Ecran allumé + curseur
+	lcd_com(0x01);//effacer
+	tpo_ms(5);
+}
+
+//envoi d'une chaine de carateres
+void lcd_str(unsigned  char *str){
+	int i=0;
+	while(str[i]!='\0'){
+		lcd_car(str[i]);
+		i=i+1;
+	}
+}
+
+
 //void main(void){
-
-//	pd10=0x0F;
-//	pu31=1;
-//	p10=0x00;
-//	while(1){
-//		t=p10;
-//		if(t!=0xF0){
-//			p10=0xFE;
-//			t=p10;
-//			if(t==0xDE){
-//				touche='2';
-//			}
-//			if(t==0x7E){
-//				touche='3';
-//			}
-//			if(t==0xBE){
-//				touche='1';
-//			}
-//			p10=0xFD;
-//			t=p10;
-//			if(t==0x7D){
-//				touche='6';
-//			}
-//			if(t==0xDD){
-//				touche='5';
-//			}
-//			if(t==0xBD){
-//				touche='4';
-//			}
-//			
-//		}
-//	}                   
+//	pd3=0xff;
+//	lcd_init();
+//	lcd_4b(0xf0);
+//	lcd_8b(0x28);
+//	lcd_car('a');
+//	lcd_car('b');
+//	lcd_str("salut");
 //}
 
 
+//Clavier
+char t;
+char touche;
+void main(void){
+
+	pd10=0x0F;
+	pu31=1;
+	p10=0x00;
+	pd3=0xff;
+	lcd_init();
+	while(1){
+		t=p10;
+		if(t!=0xF0){
+			p10=0xFE;
+			t=p10;
+			if(t==0xDE){
+				touche='2';
+				lcd_car(touche);
+			}
+			if(t==0x7E){
+				touche='3';
+				lcd_car(touche);
+			}
+			if(t==0xBE){
+				touche='1';
+			}
+			p10=0xFD;
+			t=p10;
+			if(t==0x7D){
+				touche='6';
+			}
+			if(t==0xDD){
+				touche='5';
+			}
+			if(t==0xBD){
+				touche='4';
+			}
+			
+		}
+	}                   
+}
+
+
Index: branch/sabot/sp4abc/sp4b1/SP4b1.hws
===================================================================
--- branch/sabot/sp4abc/sp4b1/SP4b1.hws	(revision 486)
+++ branch/sabot/sp4abc/sp4b1/SP4b1.hws	(revision 487)
@@ -3,12 +3,12 @@
 [DATABASE_VERSION]
 "11.0" 
 [WORKSPACE_DETAILS]
-"SP4b1" "D:\tp_sp4_SABOT\sp4abc\sp4b1" "D:\tp_sp4_SABOT\sp4abc\sp4b1\SP4b1.hws" "M16C/80,M32C" "Renesas M32C Standard" 
+"SP4b1" "D:\tp_sp4_SABOT\sabot\sp4abc\sp4b1" "D:\tp_sp4_SABOT\sabot\sp4abc\sp4b1\SP4b1.hws" "M16C/80,M32C" "Renesas M32C Standard" 
 [SHARED_WORKSPACE_CONTROL_STATUS]
 "" "" "" 
 "" "" "" 
 [PROJECTS]
-"SP4b1" "D:\tp_sp4_SABOT\sp4abc\sp4b1\SP4b1" "D:\tp_sp4_SABOT\sp4abc\sp4b1\SP4b1\SP4b1.hwp" 0 
+"SP4b1" "D:\tp_sp4_SABOT\sabot\sp4abc\sp4b1\SP4b1" "D:\tp_sp4_SABOT\sabot\sp4abc\sp4b1\SP4b1\SP4b1.hwp" 0 
 [INFORMATION]
 "No workspace information available" 
 [SCRAP]