Index: branch/boucheix/sp4a12/main2.c
===================================================================
--- branch/boucheix/sp4a12/main2.c	(nonexistent)
+++ branch/boucheix/sp4a12/main2.c	(revision 526)
@@ -0,0 +1,345 @@
+#include <stdio.h>
+#include <stdlib.h>
+#include <strings.h>
+#include <math.h>
+#include "trame.h"
+
+typedef struct t_pos{
+    float latitude;
+    float longitude;
+}Position;
+
+
+//Trames de tests à modifier si nécessaire.
+char * trames[]=  {"$GPGSV,3,2,10,15,03,077,,18,04,041,42,19,85,271,,20,08,214,*7C",
+                    "$GPGSV,3,3,10,22,39,053,50,28,15,320,*7E",
+                    "$GPRMC,141914.00,A,4545.6424,N,00306.6036,E,0.4,99.4,010206,,*0C",
+                    "$GPGLL,4545.6424,N,00306.6036,E,141914.00,A*0E",
+                    "$GPGGA,141914.00,4545.0000,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*7D",
+                    "$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39",
+                    "$GPVTG,99.4,T,,M,0.4,N,0.7,K*57",
+                    "$GPZDA,141914.00,01,02,2006,00,00*69",
+                    0};
+
+int decode_int(char c);
+int decode_trames(char * trame, Position * p);
+
+int trame_cmp(char * trame,char * type){
+    /*DECLARATION VARIABLE*/
+    int j = 0;
+    int i = 0;
+    int resultat = 1;
+    char c = type[0];
+    while (c!='\0'){//Boucle while pour détérminer la taille de la chaine de caractere type
+        i=i+1;
+        c = type[i];
+    }
+
+    while(resultat != 0 && j<i ){ // Boucle while pour comparer la trame et le type
+        if(trame[j+1] != type[j]){
+            resultat = 0;
+        }
+        j=j+1;
+    }
+    return resultat;
+
+}
+
+int decode_nombre(char * ch,int n){
+    int resultat=0;
+    for(int i=0;i<n;i++){
+
+        resultat = resultat+(pow(10,(n-i-1))*decode_int(ch[i]));
+    }
+    return resultat;
+
+}
+
+void test_unitaire_decode_nombre(void){
+
+    if(decode_nombre("123",3)!=123){
+        printf("Erreur test unitaire decode_nombre. A\n");
+        exit(-1);
+    }
+    if(decode_nombre("987654321",2)!=98){
+        printf("Erreur test unitaire decode_nombre.C\n");
+        exit(-1);
+    }
+    if(decode_nombre("12345",4)!=1234){
+        printf("Erreur test unitaire decode_int.D\n");
+        exit(-1);
+    }
+}
+
+
+int decode_int(char c)
+{
+
+	int resultat= c-48;
+	if (resultat>-1 && resultat<10){
+		return resultat;
+	}
+	else return -1;
+
+
+}
+
+void test_unitaire_decode_int(void){
+
+    if(decode_int('5')!=5){
+        printf("Erreur test unitaire decode_int. \n");
+        exit(-1);
+    }
+    if(decode_int('0')!=0){
+        printf("Erreur test unitaire decode_int. \n");
+        exit(-1);
+    }
+    if(decode_int('A')!=-1){
+        printf("Erreur test unitaire decode_int.\n");
+        exit(-1);
+    }
+    if(decode_int('Z')!=-1){
+        printf("Erreur test unitaire decode_int.\n");
+        exit(-1);
+    }
+    if(decode_int('3')!=3){
+        printf("Erreur test unitaire decode_int.\n");
+        exit(-1);
+    }
+
+}
+
+
+float conversion_latitute_float(char*degres){
+    char deg[2];
+    char min[2];
+    char sec[4];
+    float vald,valm,vals;
+    float resultat = 0;
+    int i;
+    for(i=0;i<2;i++){
+        deg[i] = degres[i];
+    }
+    for(i=2;i<4;i++){
+        min[i-2] = degres[i];
+    }
+    for(i=5;i<9;i++){
+        sec[i-5] = degres[i];
+    }
+    vald = decode_nombre(deg,2);
+    valm = decode_nombre(min,2);
+    vals = decode_nombre(sec,4);
+
+    resultat = resultat + vald;
+    resultat = resultat + valm/60;
+    resultat = resultat + ((vals*0.0001)*60)/3600;
+
+    return resultat;
+}
+
+
+float conversion_longitude_float(char*degres){
+    char deg[3];
+    char min[2];
+    char sec[4];
+    float vald,valm,vals;
+    float resultat = 0;
+    int i;
+    for(i=0;i<3;i++){
+        deg[i] = degres[i];
+    }
+    for(i=3;i<5;i++){
+        min[i-3] = degres[i];
+    }
+    for(i=6;i<10;i++){
+        sec[i-6] = degres[i];
+    }
+    vald = decode_nombre(deg,3);
+    valm = decode_nombre(min,2);
+    vals = decode_nombre(sec,4);
+
+    resultat = resultat + vald;
+    resultat = resultat + valm/60;
+    resultat = resultat + ((vals*0.0001)*60)/3600;
+
+    return resultat;
+}
+
+float conversion_lat_long_float(char*degres){
+    int i=0;
+    char c = degres[0];
+    float resultat;
+    while(c != '.'){
+        i=i+1;
+        c=degres[i];
+    }
+    if(i==4){
+      resultat=conversion_latitute_float(degres);
+    }
+    else if(i==5){
+        resultat=conversion_longitude_float(degres);
+    }
+    else {
+        printf("Erreur\n");
+        exit(-1);
+    }
+
+    return resultat;
+}
+
+
+void test_unitaire_conversion_lat_float(void){
+    float i = conversion_latitute_float("3723.2475");
+    float j = 37.3874588;
+    if(i != j ){
+        printf("Erreur test unitaire conversion lat\n");
+        exit(-1);
+    }
+}
+
+void test_unitaire_conversion_long_float(void){
+    float i = conversion_longitude_float("16322.4589");
+    float j = 163.374315;
+    if(i != j ){
+        printf("Erreur test unitaire conversion long\n");
+        exit(-1);
+    }
+}
+
+void tests_unitaires_decode_tram(void){
+    Position  p;
+
+    if(decode_trames("$GPGGA,141914.00,4545.0000,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*7D",&p)!=1){
+        printf("Erreur test unitaire decode trame\n");
+        exit(-1);
+    }
+
+}
+
+
+int decode_trames(char * trame, Position * p){
+        char buff[20];
+        int i;
+        int resultat = 1;
+
+        if(trame_cmp(trame,"GPGGA")){
+            for (i=17;i<26;i++){
+                buff[i-17] = trame[i];
+            }
+            p->latitude = conversion_lat_long_float(buff);
+
+            for(i=29;i<39;i++){
+                buff[i-29] = trame[i];
+            }
+            p->longitude = conversion_lat_long_float(buff);
+
+            if(p->latitude<0 && p->latitude>60 && p->longitude<0 && p->longitude>180){
+                resultat = 0;
+            }
+        }
+        else{
+            resultat = 0;
+        }
+
+    return resultat;
+}
+
+
+
+
+void test_unitaire_conversion_long_lat_float(void){
+    float i = conversion_lat_long_float("09013.1234");
+    float j = 90.21872333 ;
+    if(i != j ){
+        printf("Erreur test unitaire conversion long lat 1\n");
+        exit(-1);
+    }
+    i=conversion_lat_long_float("12236.3645");;
+    j=122.606075;
+    if(i != j ){
+        printf("Erreur test unitaire conversion long lat 2\n");
+        exit(-1);
+    }
+    i=conversion_lat_long_float("1832.8125");;
+    j=18.546875;
+    if(i != j ){
+        printf("Erreur test unitaire conversion long lat 3\n");
+        exit(-1);
+    }
+    i=conversion_lat_long_float("4725.7654");
+    j=47.4294233;
+    if(i != j ){
+        printf("Erreur test unitaire conversion long lat 4\n");
+        exit(-1);
+    }
+}
+
+
+
+//Fonction à modifier !!!!!
+void traitement(char * trame)
+{
+
+    static int cpt=0;
+    cpt++;
+    if(trame_cmp(trame,"GPGGA")){
+        printf ("> %s\n",trame);
+    }
+
+}
+
+//Ajouter vos tests unitaires dans cette fonction.
+void tests_unitaires(void){
+    if (5!=5){
+        printf ("Erreur Test unitaire basique.\n");
+        exit(-1);
+    }
+    if (trame_cmp("$GPGGA suite chaine","GPGGA")!=1){
+        printf ("Erreur Test unitaire trame_cmp.\n");
+        exit(-1);
+    }
+    if (trame_cmp("$GPRMC suite chaine","GPGGA")!=0){
+        printf ("Erreur Test unitaire trame_cmp.\n");
+        exit(-1);
+    }
+    if (trame_cmp("$GPRMC... ", "GPRMC" )!=1){
+        printf ("Erreur Test unitaire trame_cmp.\n");
+        exit(-1);
+    }
+    if (trame_cmp("$APRMC...", "GPGGA")!=0){
+        printf ("Erreur Test unitaire trame_cmp.\n");
+        exit(-1);
+    }
+    test_unitaire_decode_int();
+    test_unitaire_decode_nombre();
+    test_unitaire_conversion_lat_float();
+    test_unitaire_conversion_long_float();
+    test_unitaire_conversion_long_lat_float();
+    tests_unitaires_decode_tram();
+}
+
+
+
+
+// Ne pas modifier cette fonction
+int main(int argc,char ** argv)
+{
+
+    tests_unitaires();
+
+    // Affichage des trames definies dans la table trames.
+    printf ("Trames de tests tableau trames:\n");
+    int i=0;
+    while (trames[i])
+        traitement(trames[i++]);
+
+    if (!trame_init())
+        exit(-1);
+    // Affichage des trames du fichier gps.log
+    char *trame;
+    printf ("Trames de tests du fichier gps.log\n");
+    while  ((trame = trame_suivante()))
+        traitement(trame);
+
+    return 0;
+}