Index: branch/beaufour/sp4b2/SP4b2/SessionM32C_E8a_SYSTEM.ini
===================================================================
--- branch/beaufour/sp4b2/SP4b2/SessionM32C_E8a_SYSTEM.ini	(revision 538)
+++ branch/beaufour/sp4b2/SP4b2/SessionM32C_E8a_SYSTEM.ini	(revision 539)
@@ -18,6 +18,8 @@
 PROCESSOR_MODE=0
 [COMMUNI]
 COMSPEED=8
+COMSPEED PROGRAM FLASH=8
+COMSPEED DATA FLASH=8
 [Driver Configuration]
 Renesas Communications=USB interface,0,
 [Target]
Index: branch/beaufour/sp4b2/SP4b2/SessionM32C_E8a_SYSTEM.hsf
===================================================================
--- branch/beaufour/sp4b2/SP4b2/SessionM32C_E8a_SYSTEM.hsf	(revision 538)
+++ branch/beaufour/sp4b2/SP4b2/SessionM32C_E8a_SYSTEM.hsf	(revision 539)
@@ -45,7 +45,7 @@
 "{55384715-F881-421C-A548-D7D1ABE158E1}PDMRCtrlViews" "0" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_EVAL_DENORMAL_MODE" "0" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_EVAL_ROUND_MODE" "0" 
-"{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_0" "0000000000001388" 
+"{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_0" "00000000000000F0" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_1" "0000000000000000" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_10" "0000000000000000" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_11" "0000000000000000" 
@@ -53,12 +53,12 @@
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_13" "0000000000000000" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_14" "0000000000000000" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_15" "0000000000000400" 
-"{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_16" "0000000000FE02DF" 
+"{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_16" "0000000000FE0517" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_17" "0000000000FFFD00" 
-"{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_18" "0000000000000700" 
+"{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_18" "00000000000006E4" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_19" "0000000000000A00" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_2" "0000000000000000" 
-"{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_20" "0000000000000081" 
+"{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_20" "0000000000000085" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_21" "0000000000000000" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_22" "0000000000000000" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_23" "0000000000000000" 
@@ -77,7 +77,7 @@
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_35" "0000000000000000" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_4" "0000000000FE0000" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_5" "0000000000020000" 
-"{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_6" "0000000000000000" 
+"{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_6" "00000000000006F8" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_7" "0000000000000400" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_8" "0000000000000000" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_9" "0000000000000000" 
@@ -104,13 +104,21 @@
 "{AC411480-6F0A-11D5-8EB6-00004CC34E9D}ImageCtrlViews" "0" 
 "{B266D880-6FA1-11D5-8613-00A024591A38}WatchCtrlViews" "4" 
 "{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ColWidth0" "120" 
-"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ColWidth1" "150" 
+"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ColWidth1" "264" 
 "{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ColWidth12" "150" 
 "{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ColWidth2" "120" 
 "{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ColWidth3" "200" 
 "{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ECX_WATCH_ITEM0000" "c, 10, 0, P, Col, Hex, N" 
 "{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ECX_WATCH_ITEM0000_SCOPE" "Current Scope," 
-"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ECX_WATCH_ITEMCnt" "1" 
+"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ECX_WATCH_ITEM0001" "str, 10, 0, P, Col, Hex, N" 
+"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ECX_WATCH_ITEM0001_SCOPE" "Current Scope," 
+"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ECX_WATCH_ITEM0002" "touche, 10, 0, P, Col, Hex, N" 
+"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ECX_WATCH_ITEM0002_SCOPE" "Current Scope," 
+"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ECX_WATCH_ITEM0003" "p10, 10, 0, P, Col, Hex, N" 
+"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ECX_WATCH_ITEM0003_SCOPE" "Unit,SP4b2:SP4b2.x30" 
+"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ECX_WATCH_ITEM0004" "resultat, 2, 0, P, Col, Hex, MA" 
+"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ECX_WATCH_ITEM0004_SCOPE" "Current Scope," 
+"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ECX_WATCH_ITEMCnt" "5" 
 "{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd1ColWidth0" "120" 
 "{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd1ColWidth1" "150" 
 "{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd1ColWidth12" "150" 
Index: branch/beaufour/sp4b2/SP4b2/SP4b2.c
===================================================================
--- branch/beaufour/sp4b2/SP4b2/SP4b2.c	(revision 538)
+++ branch/beaufour/sp4b2/SP4b2/SP4b2.c	(revision 539)
@@ -9,6 +9,7 @@
 /*  NOTE:THIS IS A TYPICAL EXAMPLE.                                    */
 /***********************************************************************/
 #include "sfr32c87.h"
+
 #define PLCD p3;
 #define LCD_DC p3_0;
 #define LCD_RW P3_1;
@@ -28,7 +29,20 @@
 void lcd_init(void);// initialisation de l'afficheur
 void lcd_str(unsigned char *str);// envoi d'une chaîne de caractère
 
+//LCD//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
+void init_keyboard(void);
+void tpo_50ms(void) ;
 
+
+void init_keyboard(void)
+{
+	pd10 = 0x0F;
+	p10=0 ;
+	pu31 = 1; 
+}
+//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
+
+
 void lcd_4b(unsigned char c)
 {
 
@@ -61,7 +75,8 @@
 	tcspr = 0x8A;
 	ta0mr = 0x82;
 	ta0 = duree;                
-	ta0s = 1;ta0os = 1;  
+	ta0s = 1;
+	ta0os = 1;  
 	ta0ic = 0x00;                     
 	while(ir_ta0ic != 1);          
 	ta0s = 0;                      
@@ -101,8 +116,77 @@
 }
 
 
+void lcd_car(unsigned char car)
+{
+	p3_0 = 1;
+	lcd_8b(car);
+}
 
+void lcd_str(unsigned char *str)
+{
+	int i = 0;
+	while (*(str+i) != '\0')
+	{
+		lcd_car (*(str+i));
+		i++;
+	}
+}
+
+void lcd_clear (void)
+{
+	lcd_com(0x01);
+}
+
 void main(void)
 {
+	char tab[4][3]={{'1','2','3'},  // L C D ////////////////////////
+				 	{'4','5','6'},
+					{'7','8','9'},
+				 	{'*','0','#'}};
+	char resultat;  // L C D ////////////////////////
+	init_keyboard();   // L C D ////////////////////////
+	int i;
 	lcd_init();
+	while(1) //*** fonction
+	{
+		short int colone, ligne;
+ 		if ( (p10 & 0xf0)!= 0xf0 ) //le programme attend qu'une touche soit pressé  //**** bit fort != 1 -> touche pressée
+		{
+			if (p10 == 0xB0)  //Je test les différentes colone pour identifié dans laquel on ce situe
+				{colone=0;} 
+			if (p10 == 0xE0)  //Je test les différentes colone pour identifié dans laquel on ce situe
+				{colone=0;} 
+			if (p10 == 0xD0)  //((p10 & 0xf0) == 0xD0)
+				{colone=1;}
+			if (p10 == 0x70)
+				{colone=2;}
+			
+			p10 = 0x0E;	 //Je test les différentes ligne pour identifié dans laquel on ce situe
+			if ((p10 & 0xF0)!= 0xF0)
+				{ligne = 0;}
+			p10 = 0x0D;
+			if ((p10 & 0xF0)!= 0xF0)
+				{ligne = 1;}
+			p10 = 0x0B;
+			if ((p10 & 0xF0)!= 0xF0)
+				{ligne = 2;}
+			p10 = 0x07;
+			if ((p10 & 0xF0)!= 0xF0)
+				{ligne = 3;}
+			
+			
+			
+			resultat = tab[ligne][colone];
+			lcd_clear ();
+			for (i=0;i<=20;i++)
+			{
+				tpo_ms(50);
+			}
+			lcd_car(resultat);
+			
+
+		}
+		p10 = 0;
+ 	}
+	
 }
\ No newline at end of file
Index: branch/beaufour/sp4b2/SP4b2.hws
===================================================================
--- branch/beaufour/sp4b2/SP4b2.hws	(revision 538)
+++ branch/beaufour/sp4b2/SP4b2.hws	(revision 539)
@@ -21,7 +21,12 @@
 [MAKEFILE_BUILD_INFO]
 "$(WORKSPDIR)\make\$(PROJECTNAME)_$(CONFIGNAME).mak" "" "$(WORKSPDIR)\make" 0 0 0 
 [VD_CONFIGURATION_OPTIONS]
+"ACTIVE_DESKTOP" "0" 
 [VD_CONFIGURATIONS]
+"0" "Default1" "1" 
+"1" "Default2" "1" 
+"2" "Default3" "1" 
+"3" "Default4" "1" 
 [OPTIONS_DEBUG_TAB]
 0 0 0 0 0 
 [VCS]